<?php

/**
 * @param $value
 * @return mixed
 */
if (!function_exists('sanitize_full_special_chars')) {
    function sanitize_full_special_chars($value)
    {
        return filter_var($value, FILTER_SANITIZE_FULL_SPECIAL_CHARS);
    }
}

/**
 * @param $url
 * @return string
 */
if (!function_exists('escape_url')) {
    function escape_url($url)
    {
        $queryString = parse_url($url);
        if (!empty($queryString['query'])) {
            parse_str($queryString['query'], $arr);
            $arr = array_map_deep("sanitize_full_special_chars", $arr);
        }

        $urlEscape = $queryString['path'];
        if (!empty($arr)) {
            $urlEscape .= '?' . http_build_query($arr);
        }

        return $urlEscape;
    }
}

/**
 * @param $func
 * @param $arr
 * @return array
 */
if (!function_exists('array_map_deep')) {
    function array_map_deep($func, $arr)
    {

        $ret = array();
        foreach ($arr as $key => $val) {
            $key = $func($key);
            $ret[$key] = (is_array($val) ? array_map_deep($func, $val) : $func($val));
        }
        return $ret;
    }
}
